diff --git a/src/main/java/net/minecraft/core/block/NoteBlock.java b/src/main/java/net/minecraft/core/block/NoteBlock.java
index 90811c569..38ade223a 100644
--- a/src/main/java/net/minecraft/core/block/NoteBlock.java
+++ b/src/main/java/net/minecraft/core/block/NoteBlock.java
@@ -1,17 +1,28 @@
 package net.minecraft.core.block;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.NoteBlockEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
+
+import java.util.HashMap;
+import java.util.Map;
 
 public class NoteBlock extends EntityBlock
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    public static final int MASK_NOTE = 0b0011_1111;
+    public static final int MASK_POWERED = 0b1000_0000;
+
+    public static final byte MAX_NOTE = 24;
 
     public NoteBlock(String key, String namespaceId, int id)
     {
@@ -21,85 +32,179 @@ public class NoteBlock extends EntityBlock
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        if(blockId > 0 && Block.blocksList[blockId].isSignalSource())
+        boolean flag = world.hasNeighborSignal(x, y, z);
+        int data = world.getBlockMetadata(x, y, z);
+        if(isPowered(data) && !flag)
         {
-            boolean flag = world.hasDirectSignal(x, y, z);
-            NoteBlockEntity tileentitynote = (NoteBlockEntity)world.getBlockEntity(x, y, z);
-            if(tileentitynote.previousRedstoneState != flag)
-            {
-                if(flag)
-                {
-                    tileentitynote.triggerNote(world, x, y, z);
-                }
-                tileentitynote.previousRedstoneState = flag;
-            }
+            world.setBlockMetadata(x, y, z, setPowered(data, false));
+        } else if (!isPowered(data) && flag) {
+            triggerNote(world, x, y, z);
+            world.setBlockMetadata(x, y, z, setPowered(data, true));
         }
     }
 
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
-        if(world.isClientSide)
-        {
-            return true;
-        } else
-        {
-            NoteBlockEntity tileentitynote = (NoteBlockEntity)world.getBlockEntity(x, y, z);
-            tileentitynote.changePitch();
-            tileentitynote.triggerNote(world, x, y, z);
-            return true;
+        if (!world.isClientSide) {
+            changePitch(world, x, y, z);
+            triggerNote(world, x, y, z);
         }
+        return true;
     }
 
     @Override
     public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
-        NoteBlockEntity noteBlock = (NoteBlockEntity)world.getBlockEntity(x, y, z);
-        noteBlock.changePitch();
-        noteBlock.triggerNote(world, x, y, z);
+        changePitch(world, x, y, z);
+        triggerNote(world, x, y, z);
     }
 
     @Override
     public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
     {
-        if(world.isClientSide)
-        {
-            return;
-        } else
-        {
-            NoteBlockEntity tileentitynote = (NoteBlockEntity)world.getBlockEntity(x, y, z);
-            tileentitynote.triggerNote(world, x, y, z);
+        if (!world.isClientSide) {
+            triggerNote(world, x, y, z);
+        }
+    }
+
+    public void changePitch(World world, int x, int y, int z) {
+        int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockMetadata(x, y, z, setNote(meta, (getNote(meta) + 1) % (MAX_NOTE + 1)));
+    }
+
+    public void triggerNote(World world, int x, int y, int z) {
+        if(world.isBlockOpaqueCube(x, y + 1, z)) {
             return;
         }
+        world.triggerEvent(x, y, z, Instrument.getInstrumentFromBlock(world.getBlock(x, y - 1, z)).index, getNote(world.getBlockMetadata(x, y, z)));
     }
 
-    @Override
-	protected BlockEntity getNewBlockEntity()
-    {
-        return new NoteBlockEntity();
+    public static int setNote(int data, int note) {
+        return (data & ~MASK_NOTE) | note & MASK_NOTE;
+    }
+
+    public static int getNote(int data) {
+        return data & MASK_NOTE;
+    }
+
+    public static boolean isPowered(int data) {
+        return (data & MASK_POWERED) != 0;
+    }
+
+    public static int setPowered(int data, boolean flag) {
+        if (flag) {
+            return data | MASK_POWERED;
+        } else {
+            return data & ~MASK_POWERED;
+        }
     }
 
     @Override
     public void triggerEvent(World world, int x, int y, int z, int index, int data)
     {
         float f = (float)Math.pow(2D, (double)(data - 12) / 12D);
-        String s = "harp";
-        if(index == 1)
-        {
-            s = "bd";
+        String s = Instrument.getInstrumentFromIndex(index).soundKey;
+        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "note." + s, 3F, f);
+        world.spawnParticle("note", (double) x + 0.5D, (double) y + 1.2D, (double) z + 0.5D, 0.0, 0.0D, 0.0D, data);
+    }
+
+
+    // These below 2 methods are for Legacy noteblock entity support, do not delete them or terrible things will happen
+    @Override
+    public void onBlockPlacedByWorld(World world, int x, int y, int z)
+    {
+    }
+
+    @Override
+    protected BlockEntity getNewBlockEntity() {
+        return null;
+    }
+
+    public static class Instrument {
+        public static final Map<Integer, Instrument> instrumentMap = new HashMap<>();
+        public final int index;
+        public final String soundKey;
+
+        public Instrument(int index, String soundKey) {
+            this.index = index;
+            this.soundKey = soundKey;
+
+            assert !instrumentMap.containsKey(index) : "Only 1 instrument can be assigned per index!";
+            instrumentMap.put(index, this);
         }
-        if(index == 2)
-        {
-            s = "snare";
+
+        public static @NotNull Instrument getInstrumentFromIndex(int index) {
+            if (instrumentMap.containsKey(index)) return instrumentMap.get(index);
+            LOGGER.warn("No instrument assign to index '{}'!", index);
+            return instrumentMap.getOrDefault(index, DEFAULT);
         }
-        if(index == 3)
-        {
-            s = "hat";
+
+        public static @NotNull Instrument getInstrumentFromBlock(@Nullable Block block) {
+            if (block == null) return DEFAULT;
+
+            if (block == Blocks.BLOCK_OLIVINE) {
+                return CHIP_TRIANGLE;
+            }
+            if (block == Blocks.BLOCK_REDSTONE || block == Blocks.PUMPKIN_REDSTONE || block instanceof RedstoneOreBlock) { // Should be any block thats basically just redstone
+                return GUITAR_ELECTRIC;
+            }
+            if (block == Blocks.CHEST_PLANKS_OAK || block == Blocks.CHEST_PLANKS_OAK_PAINTED) {
+                return WOOD_BLOCK;
+            }
+
+            Material material = block.blockMaterial;
+            if (material == Material.permafrost || material == Material.ice) {
+                return CELESTA;
+            }
+            if(material.isStone()) {
+                return BD;
+            }
+            if(material == Material.sand) {
+                return SNARE;
+            }
+            if(material == Material.glass) {
+                return HAT;
+            }
+            if(material == Material.wood) {
+                return BASS_ATTACK;
+            }
+            if (material == Material.soulsand) {
+                return CHANT;
+            }
+            if (material == Material.steel) {
+                return DRUM_STEEL;
+            }
+
+            return DEFAULT;
         }
-        if(index == 4)
-        {
-            s = "bassattack";
+
+        public static Instrument DEFAULT;
+        public static final Instrument BD;
+        public static final Instrument SNARE;
+        public static final Instrument HAT;
+        public static final Instrument BASS_ATTACK;
+        public static final Instrument HARP;
+        public static final Instrument CHANT;
+        public static final Instrument DRUM_STEEL;
+        public static final Instrument CHIP_TRIANGLE;
+        public static final Instrument GUITAR_ELECTRIC;
+        public static final Instrument CELESTA;
+        public static final Instrument WOOD_BLOCK;
+
+        static {
+            HARP = new Instrument(0, "harp");
+            BD = new Instrument(1, "bd");
+            SNARE = new Instrument(2, "snare");
+            HAT = new Instrument(3, "hat");
+            BASS_ATTACK = new Instrument(4, "bassattack");
+            CHANT = new Instrument(5, "chant");
+            DRUM_STEEL = new Instrument(6, "drum_steel");
+            CHIP_TRIANGLE = new Instrument(7, "chip_triangle");
+            GUITAR_ELECTRIC = new Instrument(8, "guitar_electric");
+            CELESTA = new Instrument(9, "celesta");
+            WOOD_BLOCK = new Instrument(10, "wood_block");
+
+            DEFAULT = HARP;
         }
-        world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "note." + s, 3F, f);
-        world.spawnParticle("note", (double) x + 0.5D, (double) y + 1.2D, (double) z + 0.5D, (double) data / 24D, 0.0D, 0.0D, 0);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/RedstoneOreBlock.java b/src/main/java/net/minecraft/core/block/RedstoneOreBlock.java
index 73f2ae871..0ff36d174 100644
--- a/src/main/java/net/minecraft/core/block/RedstoneOreBlock.java
+++ b/src/main/java/net/minecraft/core/block/RedstoneOreBlock.java
@@ -91,6 +91,7 @@ public class RedstoneOreBlock extends Block
                 return new ItemStack[] { new ItemStack(normalBlock.get()) };
             case EXPLOSION:
             case PROPER_TOOL:
+            case PISTON_CRUSH:
                 return new ItemStack[] { new ItemStack(Items.DUST_REDSTONE, 4 + world.rand.nextInt(2)) };
             default:
                 return null;
diff --git a/src/main/java/net/minecraft/core/block/SoulSandBlock.java b/src/main/java/net/minecraft/core/block/SoulSandBlock.java
index 756f9b62c..96596648c 100644
--- a/src/main/java/net/minecraft/core/block/SoulSandBlock.java
+++ b/src/main/java/net/minecraft/core/block/SoulSandBlock.java
@@ -16,7 +16,7 @@ public class SoulSandBlock extends Block
 
     public SoulSandBlock(String key, String namespaceId, int id)
     {
-        super(key, namespaceId, id, Material.sand);
+        super(key, namespaceId, id, Material.soulsand);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/StoneBlock.java b/src/main/java/net/minecraft/core/block/StoneBlock.java
index b0499e6df..b09f44511 100644
--- a/src/main/java/net/minecraft/core/block/StoneBlock.java
+++ b/src/main/java/net/minecraft/core/block/StoneBlock.java
@@ -52,6 +52,7 @@ public class StoneBlock extends Block {
 	{
 		switch (dropCause)
 		{
+			case PISTON_CRUSH:
 			case WORLD:
 			case EXPLOSION:
 			case PROPER_TOOL:
diff --git a/src/main/java/net/minecraft/core/block/TrapDoorBlock.java b/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
index 1207293a9..91b9becea 100644
--- a/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
@@ -104,7 +104,7 @@ public class TrapDoorBlock extends Block {
 
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
-        if (blockMaterial != Material.metal) {
+        if (blockMaterial != Material.metal && blockMaterial != Material.steel) {
             int l = world.getBlockMetadata(x, y, z);
             world.setBlockMetadataWithNotify(x, y, z, l ^ MASK_OPEN);
             world.playBlockEvent(player, LevelListener.EVENT_DOOR_SOUND, x, y, z, 0);
@@ -115,7 +115,7 @@ public class TrapDoorBlock extends Block {
 
     @Override
     public void onActivatorInteract(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction) {
-        if (blockMaterial != Material.metal) {
+        if (blockMaterial != Material.metal && blockMaterial != Material.steel) {
             int l = world.getBlockMetadata(x, y, z);
             world.setBlockMetadataWithNotify(x, y, z, l ^ MASK_OPEN);
             world.playBlockEvent(null, LevelListener.EVENT_DOOR_SOUND, x, y, z, 0);
diff --git a/src/main/java/net/minecraft/core/block/entity/BlockEntity.java b/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
index c98efbf41..ee82ac748 100644
--- a/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/BlockEntity.java
@@ -178,7 +178,7 @@ public class BlockEntity implements ICarriable
         Block currentBlock = world.getBlock(x, y, z);
         int currentMeta = world.getBlockMetadata(x, y, z);
         world.removeBlockTileEntity(x, y, z);
-        world.setBlockRaw(x & 0b1111, y, z & 0b1111, 0);
+        world.setBlockRaw(x, y, z, 0);
         world.notifyBlockChange(x, y, z, 0);
         this.worldObj = null;
         this.carriedBlock = getCarriedEntry(world, holder, currentBlock, currentMeta);
diff --git a/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
index 734eafd2b..38dfb7b99 100644
--- a/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/NoteBlockEntity.java
@@ -1,79 +1,39 @@
 package net.minecraft.core.block.entity;
 
-
-// Referenced classes of package net.minecraft.src:
-//            BlockEntity, NBTTagCompound, World, Material
-
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.NoteBlock;
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.entity.Entity;
-import net.minecraft.core.world.World;
+import net.minecraft.core.util.helper.MathHelper;
 
+@Deprecated
 public class NoteBlockEntity extends BlockEntity
 {
 
-    public NoteBlockEntity()
-    {
-        note = 0;
-        previousRedstoneState = false;
-    }
 
-    @Override
-	public void writeToNBT(CompoundTag nbttagcompound)
-    {
-        super.writeToNBT(nbttagcompound);
-        nbttagcompound.putByte("note", note);
+    public byte note;
+
+    public NoteBlockEntity() {
+        note = 0;
     }
 
     @Override
-	public void readFromNBT(CompoundTag nbttagcompound)
-    {
-        super.readFromNBT(nbttagcompound);
-        note = nbttagcompound.getByte("note");
-        if(note < 0)
-        {
-            note = 0;
-        }
-        if(note > 24)
-        {
-            note = 24;
+    public void tick() {
+        if (worldObj.getBlock(x, y, z) == Blocks.NOTEBLOCK) { // Set note block pitch
+            worldObj.setBlockMetadata(x, y, z, NoteBlock.setNote(0, note));
         }
+        invalidate(); // Delete self
     }
 
-    public void changePitch()
-    {
-        note = (byte)((note + 1) % 25);
-        setChanged();
+    @Override
+	public void writeToNBT(CompoundTag tag) {
+        super.writeToNBT(tag);
+        tag.putByte("note", note);
     }
 
-    public void triggerNote(World world, int x, int y, int z)
-    {
-        if(world.isBlockOpaqueCube(x, y + 1, z))
-        {
-            return;
-        }
-        Material material = world.getBlockMaterial(x, y - 1, z);
-        byte noteIndex = 0;
-        if(material.isStone())
-        {
-            noteIndex = 1;
-        }
-        if(material == Material.sand)
-        {
-            noteIndex = 2;
-        }
-        if(material == Material.glass)
-        {
-            noteIndex = 3;
-        }
-        if(material == Material.wood)
-        {
-            noteIndex = 4;
-        }
-        world.triggerEvent(x, y, z, noteIndex, note);
+    @Override
+	public void readFromNBT(CompoundTag tag) {
+        super.readFromNBT(tag);
+        note = MathHelper.clamp(tag.getByte("note"), (byte) 0, NoteBlock.MAX_NOTE);
     }
 
-    public byte note;
-    public boolean previousRedstoneState;
-
 }
diff --git a/src/main/java/net/minecraft/core/block/material/Material.java b/src/main/java/net/minecraft/core/block/material/Material.java
index e393e9cda..7797f31d0 100644
--- a/src/main/java/net/minecraft/core/block/material/Material.java
+++ b/src/main/java/net/minecraft/core/block/material/Material.java
@@ -144,6 +144,7 @@ public class Material
     public static final Material netherrack = new Material(MaterialColor.netherrack).setConductivity(LIGHTNING_LIGHT_INSULATOR).setAsStone().notAlwaysDestroyable();
 
     public static final Material metal = new Material(MaterialColor.metal).setConductivity(LIGHTNING_STRONG_CONDUCTOR).notAlwaysDestroyable();
+    public static final Material steel = new Material(MaterialColor.steel).setConductivity(LIGHTNING_STRONG_CONDUCTOR).notAlwaysDestroyable();
     public static final Material water = new LiquidMaterial(MaterialColor.water).setConductivity(LIGHTNING_LIGHT_CONDUCTOR).destroyOnPush();
     public static final Material lava = new LiquidMaterial(MaterialColor.fire).destroyOnPush();
     public static final Material leaves = new Material(MaterialColor.plant).flammable().notSolidBlocking().destroyOnPush();
@@ -152,6 +153,7 @@ public class Material
     public static final Material cloth = new Material(MaterialColor.wool).flammable();
     public static final Material fire = new GasMaterial(MaterialColor.none).destroyOnPush();
     public static final Material sand = new Material(MaterialColor.sand);
+    public static final Material soulsand = new Material(MaterialColor.paintedBrown);
     public static final Material decoration = new DecorationMaterial(MaterialColor.none).destroyOnPush();
     public static final Material glass = new Material(MaterialColor.none).setConductivity(LIGHTNING_STRONG_INSULATOR).notSolidBlocking();
     public static final Material explosive = new Material(MaterialColor.fire).flammable().notSolidBlocking();
diff --git a/src/main/java/net/minecraft/core/block/piston/SteelPistonBaseBlock.java b/src/main/java/net/minecraft/core/block/piston/SteelPistonBaseBlock.java
index 125b9c0be..a9b82a586 100644
--- a/src/main/java/net/minecraft/core/block/piston/SteelPistonBaseBlock.java
+++ b/src/main/java/net/minecraft/core/block/piston/SteelPistonBaseBlock.java
@@ -7,9 +7,11 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.FallingBlockEntity;
+import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.IVehicle;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
@@ -115,6 +117,19 @@ public class SteelPistonBaseBlock extends PistonBaseBlock{
         return true;
     }
 
+    @Override
+    public boolean tryCrush(World world, int x, int y, int z, Direction direction) {
+        int x2 = x + direction.getOffsetX();
+        int y2 = y + direction.getOffsetY();
+        int z2 = z + direction.getOffsetZ();
+        Block block = world.getBlock(x2, y2, z2);
+        if (block == null) return true;
+        world.playBlockEvent(null, LevelListener.EVENT_BLOCK_BREAK, x2, y2, z2, world.getBlockId(x2, y2, z2));
+        block.dropBlockWithCause(world, EnumDropCause.PISTON_CRUSH, x2, y2, z2, world.getBlockMetadata(x2, y2, z2), null, null);
+        world.setBlockWithNotify(x2, y2, z2, 0);
+        return true;
+    }
+
     @Override
     public void extendEvent(World world, int x, int y, int z, int data, Direction direction) {
         List<Entity> entityList = new ArrayList<>(world.getEntitiesWithinAABBExcludingEntity(null, AABB.getTemporaryBB((double)x + direction.getOffsetX(), (double)y + direction.getOffsetY(), (double)z + direction.getOffsetZ(), (double)x + direction.getOffsetX() + 1, (double)y + direction.getOffsetY() + 1, (double)z + direction.getOffsetZ() + 1)));
diff --git a/src/main/java/net/minecraft/core/data/registry/Registries.java b/src/main/java/net/minecraft/core/data/registry/Registries.java
index 165da3f22..2540a7826 100644
--- a/src/main/java/net/minecraft/core/data/registry/Registries.java
+++ b/src/main/java/net/minecraft/core/data/registry/Registries.java
@@ -74,12 +74,12 @@ public class Registries extends Registry<Registry<?>>
         ITEM_GROUPS.register("minecraft:moss_stones",stackListOf(Blocks.MOSS_STONE, Blocks.MOSS_BASALT, Blocks.MOSS_LIMESTONE, Blocks.MOSS_GRANITE));
         ITEM_GROUPS.register("minecraft:logs",stackListOf(Blocks.LOG_OAK, Blocks.LOG_PINE, Blocks.LOG_BIRCH, Blocks.LOG_CHERRY, Blocks.LOG_EUCALYPTUS, Blocks.LOG_OAK_MOSSY, Blocks.LOG_THORN, Blocks.LOG_PALM));
         ITEM_GROUPS.register("minecraft:leaves",stackListOf(Blocks.LEAVES_OAK, Blocks.LEAVES_OAK_RETRO, Blocks.LEAVES_PINE, Blocks.LEAVES_BIRCH, Blocks.LEAVES_CHERRY, Blocks.LEAVES_EUCALYPTUS, Blocks.LEAVES_SHRUB));
-        ITEM_GROUPS.register("minecraft:coal_ores",stackListOf(Blocks.ORE_COAL_STONE, Blocks.ORE_COAL_BASALT, Blocks.ORE_COAL_LIMESTONE, Blocks.ORE_COAL_GRANITE));
-        ITEM_GROUPS.register("minecraft:iron_ores",stackListOf(Blocks.ORE_IRON_STONE, Blocks.ORE_IRON_BASALT, Blocks.ORE_IRON_LIMESTONE, Blocks.ORE_IRON_GRANITE));
-        ITEM_GROUPS.register("minecraft:gold_ores",stackListOf(Blocks.ORE_GOLD_STONE, Blocks.ORE_GOLD_BASALT, Blocks.ORE_GOLD_LIMESTONE, Blocks.ORE_GOLD_GRANITE));
-        ITEM_GROUPS.register("minecraft:lapis_ores",stackListOf(Blocks.ORE_LAPIS_STONE, Blocks.ORE_LAPIS_BASALT, Blocks.ORE_LAPIS_LIMESTONE, Blocks.ORE_LAPIS_GRANITE));
-        ITEM_GROUPS.register("minecraft:redstone_ores",stackListOf(Blocks.ORE_REDSTONE_STONE, Blocks.ORE_REDSTONE_BASALT, Blocks.ORE_REDSTONE_LIMESTONE, Blocks.ORE_REDSTONE_GRANITE, Blocks.ORE_REDSTONE_GLOWING_STONE, Blocks.ORE_REDSTONE_GLOWING_BASALT, Blocks.ORE_REDSTONE_GLOWING_LIMESTONE, Blocks.ORE_REDSTONE_GLOWING_GRANITE));
-        ITEM_GROUPS.register("minecraft:diamond_ores",stackListOf(Blocks.ORE_DIAMOND_STONE, Blocks.ORE_DIAMOND_BASALT, Blocks.ORE_DIAMOND_LIMESTONE, Blocks.ORE_DIAMOND_GRANITE));
+        ITEM_GROUPS.register("minecraft:coal_ores",stackListOf(Blocks.ORE_COAL_STONE, Blocks.ORE_COAL_BASALT, Blocks.ORE_COAL_LIMESTONE, Blocks.ORE_COAL_GRANITE, Blocks.ORE_COAL_PERMAFROST));
+        ITEM_GROUPS.register("minecraft:iron_ores",stackListOf(Blocks.ORE_IRON_STONE, Blocks.ORE_IRON_BASALT, Blocks.ORE_IRON_LIMESTONE, Blocks.ORE_IRON_GRANITE, Blocks.ORE_IRON_PERMAFROST));
+        ITEM_GROUPS.register("minecraft:gold_ores",stackListOf(Blocks.ORE_GOLD_STONE, Blocks.ORE_GOLD_BASALT, Blocks.ORE_GOLD_LIMESTONE, Blocks.ORE_GOLD_GRANITE, Blocks.ORE_GOLD_PERMAFROST));
+        ITEM_GROUPS.register("minecraft:lapis_ores",stackListOf(Blocks.ORE_LAPIS_STONE, Blocks.ORE_LAPIS_BASALT, Blocks.ORE_LAPIS_LIMESTONE, Blocks.ORE_LAPIS_GRANITE, Blocks.ORE_LAPIS_PERMAFROST));
+        ITEM_GROUPS.register("minecraft:redstone_ores",stackListOf(Blocks.ORE_REDSTONE_STONE, Blocks.ORE_REDSTONE_BASALT, Blocks.ORE_REDSTONE_LIMESTONE, Blocks.ORE_REDSTONE_GRANITE, Blocks.ORE_REDSTONE_PERMAFROST, Blocks.ORE_REDSTONE_GLOWING_STONE, Blocks.ORE_REDSTONE_GLOWING_BASALT, Blocks.ORE_REDSTONE_GLOWING_LIMESTONE, Blocks.ORE_REDSTONE_GLOWING_GRANITE, Blocks.ORE_REDSTONE_GLOWING_PERMAFROST));
+        ITEM_GROUPS.register("minecraft:diamond_ores",stackListOf(Blocks.ORE_DIAMOND_STONE, Blocks.ORE_DIAMOND_BASALT, Blocks.ORE_DIAMOND_LIMESTONE, Blocks.ORE_DIAMOND_GRANITE, Blocks.ORE_DIAMOND_PERMAFROST));
         ITEM_GROUPS.register("minecraft:nethercoal_ores", stackListOf(Blocks.ORE_NETHERCOAL_NETHERRACK));
         {
             List<ItemStack> plankStackList = new ArrayList<>();
diff --git a/src/main/java/net/minecraft/core/entity/animal/WolfMob.java b/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
index dceeb8b99..2d8d8d53b 100644
--- a/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
+++ b/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
@@ -679,6 +679,30 @@ public class WolfMob extends Animal
         super.damageEntity(newDamage, damageType);
     }
 
+    public void lavaHurt()
+    {
+        if(!fireImmune)
+        {
+            float protection = 1.0f - getArmorMaterial().getProtection(DamageType.FIRE);
+            protection = Math.max(protection, 0.01f);
+            hurt(null, 4, DamageType.FIRE);
+            remainingFireTicks = (int) (80 + 520 * protection);
+            maxFireTicks = remainingFireTicks;
+        }
+    }
+
+    public void fireHurt()
+    {
+        if(!fireImmune)
+        {
+            float protection = 1.0f - getArmorMaterial().getProtection(DamageType.FIRE);
+            protection = Math.max(protection, 0.01f);
+            hurt(null, 1, DamageType.FIRE);
+            remainingFireTicks = (int) (40 + 260 * protection);
+            maxFireTicks = remainingFireTicks;
+        }
+    }
+
     @Override
 	public boolean interact(Player entityplayer)
     {
diff --git a/src/main/java/net/minecraft/core/entity/player/Player.java b/src/main/java/net/minecraft/core/entity/player/Player.java
index f2ac316d3..5f539bfbb 100644
--- a/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -962,6 +962,30 @@ public abstract class Player extends Mob
     	
         super.damageEntity(newDamage, damageType);
     }
+
+    public void lavaHurt()
+    {
+        if(!fireImmune)
+        {
+            float protection = 1.0f - inventory.getTotalProtectionAmount(DamageType.FIRE);
+            protection = Math.max(protection, 0.01f);
+            hurt(null, 4, DamageType.FIRE);
+            remainingFireTicks = (int) (80 + 520 * protection);
+            maxFireTicks = remainingFireTicks;
+        }
+    }
+
+    public void fireHurt()
+    {
+        if(!fireImmune)
+        {
+            float protection = 1.0f - inventory.getTotalProtectionAmount(DamageType.FIRE);
+            protection = Math.max(protection, 0.01f);
+            hurt(null, 1, DamageType.FIRE);
+            remainingFireTicks = (int) (40 + 260 * protection);
+            maxFireTicks = remainingFireTicks;
+        }
+    }
     
     public void displayFurnaceScreen(FurnaceBlockEntity blockEntity)
     {
diff --git a/src/main/java/net/minecraft/core/enums/EnumDropCause.java b/src/main/java/net/minecraft/core/enums/EnumDropCause.java
index ce679d915..a55d5301b 100644
--- a/src/main/java/net/minecraft/core/enums/EnumDropCause.java
+++ b/src/main/java/net/minecraft/core/enums/EnumDropCause.java
@@ -7,5 +7,6 @@ public enum EnumDropCause
     SILK_TOUCH,
     PICK_BLOCK,
     IMPROPER_TOOL,
-    EXPLOSION
+    EXPLOSION,
+    PISTON_CRUSH;
 }
diff --git a/src/main/java/net/minecraft/core/util/helper/MathHelper.java b/src/main/java/net/minecraft/core/util/helper/MathHelper.java
index f757fa6ed..ec7b6ad36 100644
--- a/src/main/java/net/minecraft/core/util/helper/MathHelper.java
+++ b/src/main/java/net/minecraft/core/util/helper/MathHelper.java
@@ -96,6 +96,11 @@ public class MathHelper
         return Math.max(value, min);
     }
 
+    public static byte clamp(byte value, byte min, byte max) {
+        if(value > max) return max;
+        return (byte) Math.max(value, min);
+    }
+
     public static float lerp(float a, float b, float amount) {
         return a + ((b - a) * amount);
     }
diff --git a/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index c3d5908f1..117f63147 100644
--- a/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -1,6 +1,7 @@
 package net.minecraft.core.world.chunk;
 
 import com.mojang.logging.LogUtils;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.MathHelper;
@@ -535,7 +536,7 @@ public class Chunk
         blockEntity.x = xPosition * CHUNK_SIZE_X + x;
         blockEntity.y = y;
         blockEntity.z = zPosition * CHUNK_SIZE_Z + z;
-        if (getBlockID(x, y, z) == 0 || !(Block.blocksList[getBlockID(x, y, z)] instanceof EntityBlock))
+        if (!(Block.blocksList[getBlockID(x, y, z)] instanceof EntityBlock))
         {
             LOGGER.warn("Attempted to place a tile entity where there was no entity tile!");
             Thread.dumpStack();
diff --git a/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java b/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
index 09baaa878..755f6fb77 100644
--- a/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
+++ b/src/main/java/net/minecraft/datagen/WorkbenchGenerator.java
@@ -735,6 +735,7 @@ class WorkbenchGenerator {
         bricks.addInput('X', Items.BRICK_CLAY).create("clay_bricks", new ItemStack(Blocks.BRICK_CLAY, stackSize));
         bricks.addInput('X', Items.INGOT_GOLD).create("golden_bricks", new ItemStack(Blocks.BRICK_GOLD, stackSize));
         bricks.addInput('X', Items.INGOT_IRON).create("iron_bricks", new ItemStack(Blocks.BRICK_IRON, stackSize));
+        bricks.addInput('X', Items.INGOT_STEEL).create("steel_bricks", new ItemStack(Blocks.BRICK_STEEL, stackSize));
         bricks.addInput('X', Items.DYE, DyeColor.BLUE.itemMeta).create("lapis_lazuli_bricks", new ItemStack(Blocks.BRICK_LAPIS, stackSize));
         bricks.addInput('X', Blocks.SANDSTONE).create("sandstone_bricks", new ItemStack(Blocks.BRICK_SANDSTONE, stackSize));
         bricks.addInput('X', Blocks.STONE).create("stone_bricks", new ItemStack(Blocks.BRICK_STONE, stackSize));
diff --git a/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java b/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
index a554a441b..0b1b443c2 100644
--- a/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
+++ b/src/main/java/net/minecraft/server/entity/player/ServerPlayer.java
@@ -756,6 +756,11 @@ public class ServerPlayer extends Player implements ContainerListener {
 		playerNetServerHandler.sendPacket(new ChatPacket(message, 1, AES.keyChain.get(username)));
 	}
 
+    public void teleport(double x, double y, double z, float xr, float yr) {
+        playerNetServerHandler.teleportAndRotate(x, y, z, xr, yr);
+    }
+
+
     public ServerPacketHandler playerNetServerHandler;
     public MinecraftServer mcServer;
     public ServerPlayerController playerController;
